# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

%global perl_module_version 0.40

Summary:	Build, test, and install Perl modules
Name:		perl-Module-Build
Epoch:		1
Version:	0.4000
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Url:		http://search.cpan.org/dist/Module-Build/
Source0:	http://search.cpan.org/CPAN/authors/id/L/LE/LEONT/Module-Build-%{perl_module_version}.tar.gz
Patch0:		Module-Build-0.40-skip-on-5.8.0.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(Archive::Tar) >= 1.09
BuildRequires:	perl(Archive::Zip)
BuildRequires:	perl(CPAN::Meta) >= 2.110420
BuildRequires:	perl(CPAN::Meta::YAML) >= 0.03
BuildRequires:	perl(ExtUtils::CBuilder) >= 0.27
BuildRequires:	perl(ExtUtils::Manifest)
BuildRequires:	perl(ExtUtils::ParseXS) >= 2.21
BuildRequires:	perl(Module::Metadata) >= 1.000002
BuildRequires:	perl(PAR::Dist) >= 0.17
BuildRequires:	perl(Parse::CPAN::Meta) >= 1.4401
BuildRequires:	perl(Perl::OSType) >= 1
BuildRequires:	perl(Pod::Readme) >= 0.04
BuildRequires:	perl(Test::More)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Archive::Tar) >= 1.09
Requires:	perl(CPAN::Meta) >= 2.110420
Requires:	perl(ExtUtils::CBuilder) >= 0.27
Requires:	perl(ExtUtils::ParseXS) >= 2.21
Requires:	perl(Module::Signature) >= 0.21
Requires:	perl(PAR::Dist) >= 0.17
Requires:	perl(Pod::Readme) >= 0.04
Requires:	perl(Software::License)

%description
"Module::Build" is a system for building, testing, and installing Perl
modules. It is meant to be a replacement for "ExtUtils::MakeMaker".
Developers may alter the behavior of the module through subclassing in a
much more straightforward way than with "MakeMaker". It also does not
require a "make" on your system - most of the "Module::Build" code is
pure-perl and written in a very cross-platform way. In fact, you don't
even need a shell, so even platforms like MacOS (traditional) can use it
fairly easily.

%prep
%setup -q -n Module-Build-%{perl_module_version}

# Skip failing tests on RHL9/RHEL3
%patch0 -p1 

%build
perl Build.PL installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install destdir=%{buildroot} create_packlist=0
chmod u+w %{buildroot}%{_bindir}/config_data

%check
# t/PL_files.t and t/properties/share_dir.t fails on RHL-9/RHEL-3 unless patched to skip
#LANG=C ./Build test verbose=1 --test_files="t/PL_files.t t/properties/share_dir.t"

LANG=C MB_TEST_EXPERIMENTAL=1 ./Build test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{_bindir}/config_data
%{perl_vendorlib}/Module/
%{_mandir}/man1/config_data.1*
%{_mandir}/man3/Module::Build.3pm*
%{_mandir}/man3/Module::Build::*
%{perl_vendorlib}/inc/
%{_mandir}/man3/inc::latest.3pm*

%changelog
* Fri Feb 24 2012 Paul Howarth <paul@city-fan.org> 1:0.4000-1
- Update to 0.4000
  - Fixed bug with a nested directory named 'share' inside a ShareDir
    (CPAN RT#68585)
  - Fixed failing tilde.t when run under UID without passwd entry
    (CPAN RT#67893)
  - Fixed bug where modules without $VERSION might have a version of '0' listed
    in 'provides' metadata, which will be rejected by PAUSE
  - Fixed bug in PodParser to allow numerals in module names
  - Fixed bug where giving arguments twice led to them becoming arrays,
    resulting in install paths like "ARRAY(0xdeadbeef)/lib/Foo.pm"
  - Fixed typo in Module::Build documentation (CPAN RT#67008)
  - Pod to HTML internals changed to support new Pod::Html work in the Perl
    core
  - Fixed deviance from alphabetical order in documentation of constructor
    parameters
  - Add documentation for configure_requires constructor parameter
  - Change some of the docs' language describing relationship to MakeMaker
  - List Perl-Toolchain-Gang repo as official repo
- Update RHL-9/RHEL-3 patch to apply cleanly

* Thu Jul  7 2011 Paul Howarth <paul@city-fan.org> 1:0.3800-3
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Mar 30 2011 Paul Howarth <paul@city-fan.org> 1:0.3800-2
- Explicitly require perl(CPAN::Meta) >= 2.110420, needed for creation of
  MYMETA files by Build.PL

* Sun Mar  6 2011 Paul Howarth <paul@city-fan.org> 1:0.3800-1
- Update to 0.3800
  - Generates META.json and MYMETA.json consistent with version 2 of the CPAN
    Meta Spec
  - Autogenerated documentation no longer includes private actions from
    Module::Build's own release subclass
- Drop buildreq perl(Module::Signature) and test GPG keys as Module::Signature
  is faked out in the test suite now
- Replace buildreq perl(CPAN::Meta::YAML) with perl(CPAN::Meta) >= 2.110420 and
  perl(Parse::CPAN::Meta) >= 1.4401
- Drop explicit buildreq perl(version) >= 0.87 (still pulled in via
  Module::Metadata)

* Fri Jan 28 2011 Paul Howarth <paul@city-fan.org> 1:0.3624-1
- Update to 0.3624
  - Fixed pod2html directory bugs
  - Fixed creation of spurious blib directory in core perl directory when
    running install.t (CPAN RT#63003)

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> 1:0.3623-1
- Update to 0.3623
  - Fixed bugs involving bootstrapping configure_requires prerequisites on
    older CPANPLUS clients or for either CPAN/CPANPLUS when using the
    compatibility Makefile.PL
  - Added diagnostic output when configure_requires are missing for the
    benefit of users doing manual installation

* Tue Jan 25 2011 Paul Howarth <paul@city-fan.org> 1:0.3622-1
- Update to 0.3622
  - Give a list of valid licenses when given one we don't recognize
    (CPAN RT#55951)
  - Improve HTML documentation generation on ActivePerl (CPAN RT#53478)
  - Won't try to use ActivePerl doc generation tools without confirming that
    they are indeed installed
  - Handle META/MYMETA reading and writing within Module::Build to ensure utf8
    mode on filehandles
  - Fix runtime error on cygwin when searching for an executable command
    during installdeps testing
  - Add install*script to search path for installdeps client and search site,
    then vendor, then core paths
  - Set temporary $ENV{HOME} in testing to an absolute path, which fixes
    some issues when tested as part of the Perl core
  - Module::Build::ModuleInfo now warns instead of dying when a module has an
    invalid version;  ->version now just returns undef (CPAN RT#59593)
  - Add 'Build manifest_skip' action to generate a default MANIFEST.SKIP
  - When temporarily generating a MANIFEST.SKIP when none exists, it will be
    removed on exit instead of hanging around until 'Build clean'; this is less
    surprising/confusing and the 'Build manifest_skip' action is now available
    instead to bootstrap the file
  - Add 'distinstall' action to run 'Build install' inside the generated
    distribution directory
  - Add 'release_status' and 'dist_suffix' properties in preparation for
    adding CPAN Meta Spec 2 support; 'dist_suffix' will be set to 'TRIAL'
    automatically when necessary
  - Module::Build::Compat will now convert dotted-decimal prereqs into decimal
    rather than dying (and will warn about this)
  - Skips 'release_status' tests on perl < 5.8.1 due to buggy treatment of
    dotted-decimal version numbers
  - PERL_DL_NONLAZY is now always set when tests are run (CPAN RT#56055)
  - Cache case-sensitivity checks to boost performance
    (CPAN RT#55162, CPAN RT#56513)
  - When parsing a version number out of a file, any trailing alphabetical
    characters will be dropped to avoid fatal errors when comparing version
    numbers; these would have been dropped (with a warning) anyway during an
    ordinary numeric comparison (CPAN RT#56071)
  - A Perl interpreter mismatch between running Build.PL and running Build
    is now a fatal error, not a warning (CPAN RT#55183)
  - Build script now checks that M::B is at least the same version of M::B as
    provided in 'configure_requires' in META (CPAN RT#54954)
  - No longer uses fake user 'foo' in t/tilde (CPAN RT#61793)
  - 'fakeinstall' will use .modulebuildrc actions for 'install' if no specific
    'fakeinstall' options are provided (CPAN RT#57279)
  - When authors do not specify Module::Build in configure_requires and
    Module::Build is automatically added, a warning will be issued showing the
    added prerequisite
  - Move automatic configure_requires generation into get_metadata() and added
    an 'auto' argument to toggle it (on for META and off for MYMETA)
  - Correctly report missing metafile field names
  - A broken version.pm load won't cause Module::Build::Version to die trying
    to install itself as a mock version (CPAN RT#59499)
  - Better error message in case package declaration is not found when
    searching for version
  - Make 'license' more liberal: you can now specify either a license key from
    the approved list (c.f. Module::Build::API) or just a Software::License
    subclass name (e.g. 'Perl_5'); this should provide better support for
    custom or proprietary licenses
  - Add a mock Software::License to prevent t/properties/license.t from failing
  - Arguments with key value pairs may now have keys with "-" in them
    (CPAN RT#53050)
  - Won't fail tests if an ancient Tie::IxHash is installed
  - Add dependency on Perl::OSType to refactor and centralize management of OS
    type mapping
  - Perl::OSType is declared as a 'configure_requires' dependency, but is also
    bundled in inc (and loaded if needed)
  - Return to starting directory after install action; this is an attempt to
    fix an install.t heisenbug (CPAN RT#63003)
  - Add quotemeta to t/tilde.t test to fix Cygwin fails
  - Skip noexec tmpdir check on Windows (CPAN RT#55667)
  - Changed YAML::Tiny references to the new CPAN::Meta::YAML module instead,
    which is the YAML-variant that is going into the Perl core
  - Module::Build::YAML has been deprecated; Module::Build now depends directly
    upon CPAN::Meta::YAML (M::B::YAML remains as a subclass wrapper)
  - Module::Build::ModuleInfo has been deprecated; Module::Build now depends
    directly upon Module::Metadata (which is an extraction of M::B::ModuleInfo
    intended for general reuse); a pure-perl version has been bundled in inc/
    solely for bootstrapping in case configure_requires is not supported
    (M::B::ModuleInfo remains as a wrapper around Module::Metadata)
  - Module::Build::Version has been deprecated; Module::Build now depends
    directly upon version.pm; a pure-perl version has been bundled in inc/
    solely for bootstrapping in case configure_requires is not supported
    (M::B::Version remains as a wrapper around version.pm)
  - The YAML_support feature has been removed
- Drop workaround for gnupg2 now that %%{__gpg} can safely be assumed to
  be gnupg version 1
- Package LICENSE
- Clean up Requires/BuildRequires and add version requirements
- Drop runtime dependency on perl(Archive::Zip), used only in test suite
- Drop perl(Software::License) buildreq; can use bundled version
- Drop all dependencies on perl(YAML::Tiny)
- BR: perl(CPAN::Meta::YAML) >= 0.002
- BR: perl(Module::Metadata) >= 1.000002
- BR: perl(Perl::OSType) >= 1

* Fri Jul 23 2010 Paul Howarth <paul@city-fan.org> 1:0.3607-4
- No longer need to exclude inc::latest on Rawhide

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> 1:0.3607-3
- Rebuild for perl 5.12.1 in Rawhide
- Exclude inc::latest from perl 5.12.x builds for now as it conflicts with the
  main perl package (#607505)

* Tue May 11 2010 Paul Howarth <paul@city-fan.org> 1:0.3607-2
- Fix dist tag for RHEL-6 Beta

* Fri Apr  7 2010 Paul Howarth <paul@city-fan.org> 1:0.3607-1
- Update to 0.3607
  - 'dist' action now always ensures a clean dist directory for tarball
  - Migrated repository to git and updated META.yml to match
  - Removed bugtracker URL (let search.cpan.org use default)
  - Disabled SIGNATURE generation

* Thu Apr  1 2010 Paul Howarth <paul@city-fan.org> 1:0.3605-1
- Update to 0.3605
  - Added missing newline to "Changing sharpbang" messages (CPAN RT#54474)
  - Added 'beos' to list of Unix-like OS types (CPAN RT#53876)
  - Sets $ENV{HOME} to a temporary directory during testing
  - For VMS: fixed prefix handling plus other test fixes
  - Support anonymous array of directories for c_source
  - Small POD formatting fix
- Use ${GNUPGHOME} environment variable to specify key locations, so we
  can avoid writing files within ${HOME}

* Thu Jan 28 2010 Paul Howarth <paul@city-fan.org> 1:0.3603-2
- BuildRequire/Require perl(Software::License)
- Require perl(YAML::Tiny) rather than perl(YAML)

* Fri Jan 22 2010 Paul Howarth <paul@city-fan.org> 1:0.3603-1
- Epoch bump for valid comparison with current Fedora package

* Tue Jan 19 2010 Paul Howarth <paul@city-fan.org> 0.3603-1
- Update to 0.3603
- Module::Build::Compat would croak on distibutions that set requires 'perl'
  to a dotted decimal like '5.6.2'. We now skip that key since it doesn't go
  into PREREQ_PM and we numify it properly for 'use 5.006002' in the
  generated Makefile.PL (CPAN RT#53409)
- Fix failures in t/properties/needs_compiler.t when $ENV{CC} is set
  (CPAN RT#53296)

* Tue Dec 22 2009 Paul Howarth <paul@city-fan.org> 0.3601-1
- Update to 0.3601 (see Changes for details)
- Run tests for experimental features
- Replace BR: perl(YAML) with perl(YAML::Tiny)

* Mon Dec 21 2009 Paul Howarth <paul@city-fan.org> 0.3600-1
- Update to 0.36
- Update t/PL_files.t patch and rename to skip-on-5.8.0 patch as it now
  patches t/properties/share_dir.t too
- Package %%{perl_vendorlib}/inc/
- GPGv2 as found in F-13 and later will not allow us to import secret keys
  so provide a pre-built keyring instead if necessary
- Dist tag for Rawhide no longer needs special-casing

* Thu Aug 27 2009 Paul Howarth <paul@city-fan.org> 0.3500-1
- Update to 0.35 (various fixes - see Changes file)

* Mon Aug 10 2009 Paul Howarth <paul@city-fan.org> 0.3402-1
- Update to 0.340201 (fix CPAN RT#47980)

* Wed Jul  8 2009 Paul Howarth <paul@city-fan.org> 0.3400-1
- Update to 0.34 (many changes - see Changes file)
- New upstream maintainer -> new source URL
- Skip t/PL_files.t on RHL9/RHEL3 (perl 5.8.0), fails for reason unknown

* Fri May  8 2009 Paul Howarth <paul@city-fan.org> 0.3300-2
- Add perl(Archive::Zip) and perl(Pod::Readme) as reqs/buildreqs
- Add explicit reqs perl(Archive::Tar), perl(Module::Signature), perl(version)

* Mon May  4 2009 Paul Howarth <paul@city-fan.org> 0.3300-1
- Update to 0.33
- Buildreq perl(Archive::Tar)
- Buildreq perl(Module::Signature) and enable signature check

* Thu Feb 26 2009 Paul Howarth <paul@city-fan.org> 0.3200-1
- Update to 0.32
- Update to SLES-compatible dist tag macros
- Specify destdir in %%install rather than %%build to pacify rpmlint

* Thu Jan 22 2009 Paul Howarth <paul@city-fan.org> 0.3100.12-1
- Update to 0.31012
- New upstream maintainer -> new source URL
- Add buildreq perl(PAR::Dist) for extra test coverage

* Mon Dec 22 2008 Paul Howarth <paul@city-fan.org> 0.3100-1
- Update to 0.31

* Fri Sep 26 2008 Paul Howarth <paul@city-fan.org> 0.3000-1
- Update to 0.30 (rpm version 0.3000 due to perl versioning not working like
  rpm versioning)
- Add buildreqs perl(ExtUtils::Manifest) and perl(Test::More)
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Mon Apr 30 2007 Paul Howarth <paul@city-fan.org> 0.2808-1
- Update to 0.2808
- Add req/buildreq perl(ExtUtils::ParseXS) for added functionality
- Require perl(ExtUtils::CBuilder) and perl(YAML)

* Mon Mar 26 2007 Paul Howarth <paul@city-fan.org> 0.2807-1
- Update to 0.2807
- Buildreq perl(YAML) for better test support
- Restore optional buildreq perl(version), no longer a BR loop

* Sun Mar 18 2007 Paul Howarth <paul@city-fan.org> 0.2806-2
- No longer need to buildreq perl(version)

* Mon Dec 18 2006 Paul Howarth <paul@city-fan.org> 0.2806-1
- Update to 0.2806
- Fix dist tag for development releases

* Mon Jul 31 2006 Paul Howarth <paul@city-fan.org> 0.2805-1
- Update to 0.2805
- Define %%__id_u in a more portable way
- Buildreq perl(ExtUtils::CBuilder) and perl(version)
- Use --destdir option to Build.PL
- Run testsuite in C locale (CPAN RT#19406)

* Fri Mar  3 2006 Paul Howarth <paul@city-fan.org> 0.2612-1
- Update to 0.2612
- Use macros instead of variables (packager's cosmetic preference)
- Simplify distribution=detection
- Remove redundant macros __perl_version, __perl_package, and perl_vendorarch
- Use search.cpan.org URLs
- Don't bother with compiler optimization flags in a noarch package
- Remove buildroot unconditionally in %%clean and %%install
- Fix directory ownership
- Don't try testing the signature

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> 0.2611-1
- Update to 0.2611
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Remove MANIFEST and INSTALL from %%doc
- Explicitly list packaged files

* Wed Apr 20 2005 Paul Howarth <paul@city-fan.org> 0.2610-1
- Update to 0.2610

* Fri Apr  1 2005 Paul Howarth <paul@city-fan.org> 0.2609-1
- Update to 0.2609

* Wed Feb  9 2005 Paul Howarth <paul@city-fan.org> 0.2608-1
- Update to 0.2608

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> 0.26-1
- Update to 0.26
- Tidy up spec file

* Mon May 10 2004 Paul Howarth <paul@city-fan.org> 0.25-1
- Initial build
